
<xsl:stylesheet version="1.0" xmlns="http://www.hyfinity.com/xfactory" xmlns:xstore="http://www.hyfinity.com/xstore" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:hy="http://www.hyfinity.com/xengine" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output encoding="UTF-8" indent="yes" method="xml" version="1.0"/>
    <xsl:variable name="Chosen_Name_Prefix">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Name_Prefix']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Project_Layer">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Project_Layer']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Collection">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Collection']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Pattern_Instance_Pool">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Pattern_Instance_Pool']"/>
    </xsl:variable>
    <xsl:variable name="Blueprint_Instance_Name">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Blueprint_Instance_Name']"/>
    </xsl:variable>
    <!--
    match on root template to begin processing
    -->
    <xsl:template match="/">
        <Control_Patterns xmlns="http://www.hyfinity.com/xfactory">
            <xsl:apply-templates mode="process_control_pattern" select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:service"/>
        </Control_Patterns>
    </xsl:template>
    <xsl:template match="wsdl:service" mode="process_control_pattern">
        <!-- We create a pattern for each service that is found and treat each one as a seperate entity-->
        <!-- The name and pattern_id come from the name of the service and will be referenced with corresponding names from the blueprint -->
        <pattern base="" desc="Service Integration" image="" version="1.0"
                 name="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}.xml"
                 pattern_id="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}">
            <nodes>
                <node desc="Handles the Request and Response Messages to an Exposed Service"
                      name="Access_Service"
                      node_id="Access_Service"
                      protocol="java"
                      runtime_instance=""
                      runtime_location=""
                      type="xagent">

                    <actions>
                        <action alias="Invoke" content_type="xml" desc="" name="requestInboundService">
                            <input desc="" message_name="" message_ref="" name="request" type="org.w3c.dom.Node"/>
                            <output desc="" message_name="" message_ref="" name="response" type="org.w3c.dom.Node"/>
                        </action>
                    </actions>
                    <engine desc="Engine" name="Engine" runtime_instance="com.hyfinity.xengine.XEngine" type="xengine">
                        <logicsheet desc="Rules" logicsheet_ref="{$Blueprint_Instance_Name}_Logicsheet_pool" name="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}_Access_Service_Rules"/>
                        <other_resources>
                            <other_resource type="xsl" resource_ref="{$Blueprint_Instance_Name}_XSL_pool">
                                <xsl:attribute name="name">
                                    <xsl:choose>
                                        <xsl:when test="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='soap_wrapper_id' and . != '']">
                                            <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='soap_wrapper_id']" />
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:text>Soap_Wrapper</xsl:text>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:attribute>
                            </other_resource>
                        </other_resources>
                    </engine>
                </node>
            </nodes>
        </pattern>
    </xsl:template>
</xsl:stylesheet>
