<xsl:stylesheet version="1.0" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:hy="http://www.hyfinity.com/xengine" xmlns="http://www.hyfinity.com/xfactory" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xstore="http://www.hyfinity.com/xstore" xmlns:exsl="http://exslt.org/common" exclude-result-prefixes="exsl" extension-element-prefixes="exsl">
    <xsl:output indent="yes" method="xml"/>
    <xsl:variable name="Blueprint_Type">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Blueprint_Type']"/>
    </xsl:variable>
    <xsl:variable name="Blueprint_Instance">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Blueprint_Instance_Name']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Name_Prefix">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Name_Prefix']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Project_Layer">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Project_Layer']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Collection">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Collection']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Pattern_Instance_Pool">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Pattern_Instance_Pool']"/>
    </xsl:variable>
    <xsl:variable name="Namespace_Prefix">
        <xsl:value-of select="substring-before(/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:service/wsdl:port/@binding,':')"/>
    </xsl:variable>
    <xsl:variable name="Namespace_Address">
        <xsl:value-of select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/namespace::*[name() = $Namespace_Prefix]"/>
    </xsl:variable>
    <xsl:variable name="targetNamespaceAddress" select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/@targetNamespace"/>
    <xsl:variable name="targetNamespaceName">
        <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/namespace::*">
            <xsl:if test=". = $targetNamespaceAddress">
                <xsl:value-of select="name()"/>
            </xsl:if>
        </xsl:for-each>
    </xsl:variable>
    <xsl:template match="/">
        <xsl:element name="Logicsheets" namespace="http://www.hyfinity.com/xfactory">
            <!-- loop through each of the services in the wsdl - one access service node is created for each wsdl service-->
            <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:service">
                <xsl:element name="Logicsheet">
                    <xsl:attribute name="service_name"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:variable name="service_name" select="@name"/>
                    <xsl:text disable-output-escaping="yes">&lt;</xsl:text>
                    <xsl:text disable-output-escaping="yes">hy:rulebase xmlns="http://www.hyfinity.com/xengine" xmlns:hy="http://www.hyfinity.com/xengine" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" forward_chain="false" disable="true" cache="false" context="/" return="$return" </xsl:text>

                    <!-- Find all the namespaces defined in the wsdl files so these can be output in the logicsheet.
                         These are first converted into a temporary node set so we can easily check and remove duplicates. -->
                    <xsl:variable name="ns">
                        <namespaces xmlns="">
                            <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/namespace::*">
                                <xsl:if test="name() and name()!='soap' and name() != 'xml' and name() != 'hy'">
                                    <namespace prefix="{name()}" value="{.}"/>
                                </xsl:if>
                            </xsl:for-each>
                            <!--Namespaces for rpc wsdl. Avoid duplicates -->
                            <xsl:if test="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding/wsdl:operation/wsdl:input/soap:body/@namespace">
                                <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding/wsdl:operation[not(@name = preceding-sibling::wsdl:operation/@name)]">
                                    <namespace prefix="{@name}" value="{wsdl:input/soap:body/@namespace}"/>
                                </xsl:for-each>
                            </xsl:if>
                        </namespaces>
                    </xsl:variable>
                    <xsl:variable name="nsSet" select="exsl:node-set($ns)"/>
                    <xsl:for-each select="$nsSet/namespaces/namespace[not(@prefix = preceding-sibling::namespace/@prefix)]">
                        <xsl:text disable-output-escaping="yes">xmlns:</xsl:text>
                        <xsl:value-of select="@prefix"/>
                        <xsl:text disable-output-escaping="yes">="</xsl:text>
                        <xsl:value-of select="@value"/>
                        <xsl:text disable-output-escaping="yes">" </xsl:text>
                    </xsl:for-each>


                    <!--Namespaces for rpc wsdl -->
                    <!--<xsl:if test="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding/wsdl:operation/wsdl:input/soap:body/@namespace">
                        <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding/wsdl:operation[not(@name = preceding-sibling::wsdl:operation/@name)]">
                            <xsl:text>xmlns:</xsl:text>
                            <xsl:value-of select="@name"/>
                            <xsl:text>=</xsl:text>
                            <xsl:text disable-output-escaping="yes">"</xsl:text>
                            <xsl:value-of select="wsdl:input/soap:body/@namespace"/>
                            <xsl:text disable-output-escaping="yes">" </xsl:text>
                        </xsl:for-each>
                    </xsl:if>-->
                    <xsl:text disable-output-escaping="yes">&gt;</xsl:text>
                    <xsl:element name="soap:dummy"/>
                    <xsl:element name="workspace">
                        <xsl:attribute name="name"><xsl:text>return</xsl:text></xsl:attribute>
                    </xsl:element>
                    <xsl:call-template name="add_optional_soap_wrapper"/>
                    <xsl:apply-templates mode="service_calls" select="./wsdl:port">
                        <xsl:with-param name="service_name" select="$service_name"/>
                        <xsl:with-param name="targetNamespaceName" select="$targetNamespaceName"/>
                    </xsl:apply-templates>
                    <xsl:call-template name="failure_case"/>
                    <xsl:call-template name="success_case"/>
                    <xsl:text disable-output-escaping="yes">&lt;/hy:rulebase&gt;</xsl:text>
                    <!--</xsl:element>-->
                </xsl:element>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>
    <xsl:template name="failure_case">
        <xsl:element name="hy:rule">
            <xsl:attribute name="disable">false</xsl:attribute>
            <xsl:attribute name="desc"><xsl:text>This is the fault or failure case for a service response</xsl:text></xsl:attribute>
            <xsl:attribute name="id"><xsl:text>Handle_Fault_Response</xsl:text></xsl:attribute>
            <xsl:attribute name="priority"><xsl:text>30</xsl:text></xsl:attribute>
            <xsl:element name="hy:head">
                <xsl:element name="hy:result">
                    <xsl:attribute name="id"><xsl:text>Remove_Soap_Wrapper</xsl:text></xsl:attribute>
                    <xsl:element name="hy:operator">
                        <xsl:text>Copy</xsl:text>
                    </xsl:element>
                    <xsl:element name="hy:target">
                        <xsl:attribute name="action"><xsl:text>add</xsl:text></xsl:attribute>
                        <xsl:attribute name="name"><xsl:text>factbase</xsl:text></xsl:attribute>
                        <xsl:attribute name="update"><xsl:text>append</xsl:text></xsl:attribute>
                        <xsl:element name="hy:params">
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>from_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/soap:Envelope/soap:Body/*</xsl:text>
                            </xsl:element>
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>to_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>$return</xsl:text>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
            <xsl:element name="hy:body">
                <xsl:element name="clause" xmlns="http://www.hyfinity.com/xengine">
                    <xsl:attribute name="id"><xsl:text>Check_for_Fault</xsl:text></xsl:attribute>
                    <xsl:attribute name="multiple"><xsl:text>false</xsl:text></xsl:attribute>
                    <xsl:element name="operator">
                        <xsl:text>Read</xsl:text>
                    </xsl:element>
                    <xsl:element name="target">
                        <xsl:attribute name="action"><xsl:text>eval</xsl:text></xsl:attribute>
                        <xsl:attribute name="name"><xsl:text>factbase</xsl:text></xsl:attribute>
                        <xsl:element name="params">
                            <xsl:element name="param">
                                <xsl:attribute name="name"><xsl:text>xpath_expression</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/soap:Envelope/soap:Body/soap:Fault</xsl:text>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- outputs the rules needed to handle a successful response -->
    <xsl:template name="success_case">

        <!-- If there is no soap header information then strip of the wrapper and return the contents of the soap:body -->
        <hy:rule disable="false" desc="This is the success case for a service response, where the response only contains information in the SOAP Body.  This information is stripped out and returned" id="Handle_Success_Response_no_Header" priority="30">
            <hy:head>
                <hy:result id="Remove_Soap_Wrapper">
                    <hy:operator>Copy</hy:operator>
                    <hy:target action="add" name="factbase" update="append">
                        <hy:params>
                            <hy:param name="from_location" type="com.hyfinity.xpath.XPath">/soap:Envelope/soap:Body/*</hy:param>
                            <hy:param name="to_location" type="com.hyfinity.xpath.XPath">$return</hy:param>
                        </hy:params>
                    </hy:target>
                </hy:result>
            </hy:head>
            <hy:body>
                <hy:and>
                    <hy:clause id="Check_for_Success" multiple="false">
                        <hy:operator>Read</hy:operator>
                        <hy:target action="eval" name="factbase">
                            <hy:params>
                                <!--this xpath just checks to see if the message returned is successful by finding a non-fault-->
                                <hy:param name="xpath_expression" type="com.hyfinity.xpath.XPath">not(/soap:Envelope/soap:Body/soap:Fault)</hy:param>
                            </hy:params>
                        </hy:target>
                    </hy:clause>
                    <hy:clause id="Check_no_header_content" multiple="false">
                        <hy:operator>Read</hy:operator>
                        <hy:target action="eval" name="factbase">
                            <hy:params>
                                <hy:param name="xpath_expression" type="com.hyfinity.xpath.XPath">not(/soap:Envelope/soap:Header/*)</hy:param>
                            </hy:params>
                        </hy:target>
                    </hy:clause>
                </hy:and>
            </hy:body>
        </hy:rule>

        <!-- If there is information in the header, then just return the full SOAP envelope -->
        <hy:rule disable="false" desc="This is the success case for a service response, where the response contains information in both the SOAP Header and Body.  This just returns the full SOAP Envelope recieved" id="Handle_Success_Response_with_Header" priority="30">
            <hy:head>
                <hy:result id="Return_Soap_Wrapper">
                    <hy:operator>Copy</hy:operator>
                    <hy:target action="add" name="factbase" update="append">
                        <hy:params>
                            <hy:param name="from_location" type="com.hyfinity.xpath.XPath">/soap:Envelope</hy:param>
                            <hy:param name="to_location" type="com.hyfinity.xpath.XPath">$return</hy:param>
                        </hy:params>
                    </hy:target>
                </hy:result>
            </hy:head>
            <hy:body>
                <hy:and>
                    <hy:clause id="Check_for_Success" multiple="false">
                        <hy:operator>Read</hy:operator>
                        <hy:target action="eval" name="factbase">
                            <hy:params>
                                <!--this xpath just checks to see if the message returned is successful by finding a non-fault-->
                                <hy:param name="xpath_expression" type="com.hyfinity.xpath.XPath">not(/soap:Envelope/soap:Body/soap:Fault)</hy:param>
                            </hy:params>
                        </hy:target>
                    </hy:clause>
                    <hy:clause id="Check_for_header_content" multiple="false">
                        <hy:operator>Read</hy:operator>
                        <hy:target action="eval" name="factbase">
                            <hy:params>
                                <hy:param name="xpath_expression" type="com.hyfinity.xpath.XPath">/soap:Envelope/soap:Header/*</hy:param>
                            </hy:params>
                        </hy:target>
                    </hy:clause>
                </hy:and>
            </hy:body>
        </hy:rule>

    </xsl:template>
    <!-- Loop through each service/port -->
    <!--Service calls-->
    <xsl:template match="wsdl:port" mode="service_calls">
        <xsl:param name="service_name"/>
        <xsl:param name="targetNamespaceName"/>
        <!-- check for existence of soap address -->
        <xsl:if test="./soap:address">
            <!-- create binding name binding variable in port element -->
            <xsl:variable name="binding_name">
                <xsl:choose>
                    <xsl:when test="contains(@binding, ':')">
                        <xsl:value-of select="substring-after(@binding,':')"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="@binding"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <!-- create port name variable to ensure the proxy node used in the call services has the same name as that used in the Proxy Pattern -->
            <xsl:variable name="port_name">
                <xsl:value-of select="@name"/>
            </xsl:variable>
            <!-- go through each of the binding tags where it matches the binding_name variable -->
            <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding[@name=$binding_name]">
                <xsl:variable name="binding" select="."/>
                <xsl:variable name="port_type">
                    <xsl:choose>
                        <xsl:when test="contains(@type, ':')">
                            <xsl:value-of select="substring-after(@type,':')"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="@type"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>

                <xsl:for-each select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:portType[@name=$port_type]">
                    <xsl:for-each select="./wsdl:operation">

                        <xsl:variable name="soap_operation" select="@name"/>

                        <!-- The message style (either 'rpc' or 'document') can be set on either the soap:operation element or the soap:binding
                             If present, the operation style takes precedence. -->
                        <xsl:variable name="style">
                            <xsl:choose>
                                <xsl:when test="$binding/wsdl:operation[@name = $soap_operation]/soap:operation/@style[. != '']" >
                                    <xsl:value-of select="$binding/wsdl:operation[@name = $soap_operation]/soap:operation/@style" />
                                </xsl:when>
                                <xsl:otherwise >
                                    <xsl:value-of select="$binding/soap:binding/@style" />
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:variable>

                        <xsl:variable name="input_message">
                            <xsl:choose>
                                <xsl:when test="contains(wsdl:input/@message, ':')">
                                    <xsl:value-of select="substring-after(wsdl:input/@message,':')"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:value-of select="wsdl:input/@message"/>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:variable>
                        <xsl:variable name="soap_action">
                            <xsl:value-of select="$binding/wsdl:operation[@name=$soap_operation]/soap:operation/@soapAction"/>
                        </xsl:variable>
                        <xsl:choose>
                            <xsl:when test="$style='document' and /xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:message[@name=$input_message]/wsdl:part/@element">
                                <xsl:variable name="message_root_name">
                                    <!-- Check if the element reference is correctly prefixed, or is relying on the default namespace -->
                                    <xsl:choose>
                                        <xsl:when test="contains(/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:message[@name=$input_message]/wsdl:part/@element, ':')">
                                            <xsl:value-of select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:message[@name=$input_message]/wsdl:part/@element"/>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:variable name="defaultNS" select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/namespace::*[name() = '']"/>
                                            <xsl:variable name="nsPrefix" select="name((/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/namespace::*[. = $defaultNS and name() != ''])[1])"/>
                                            <xsl:choose>
                                                <xsl:when test="$nsPrefix != ''" >
                                                    <xsl:value-of select="$nsPrefix" />
                                                    <xsl:text>:</xsl:text>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                    <!-- cant find a defined prefix for the namespace, so what should we output??
                                                         TODO: In this case, we should be generating a prefix, and making sure it gets output on the rulebase tag -->
                                                </xsl:otherwise>
                                            </xsl:choose>
                                            <xsl:value-of select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:message[@name=$input_message]/wsdl:part/@element"/>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:variable>
                                <xsl:call-template name="create_service_call">
                                    <xsl:with-param name="binding_name" select="$binding_name"/>
                                    <xsl:with-param name="input_message" select="$input_message"/>
                                    <xsl:with-param name="soap_action" select="$soap_action"/>
                                    <xsl:with-param name="service_name" select="$service_name"/>
                                    <xsl:with-param name="message_root_name" select="$message_root_name"/>
                                    <xsl:with-param name="soap_operation" select="$soap_operation"/>
                                    <xsl:with-param name="port_type" select="$port_type"/>
                                    <xsl:with-param name="port_name" select="$port_name"/>
                                    <xsl:with-param name="style" select="$style"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:when test="$style='rpc' and /xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:message[@name=$input_message][wsdl:part/@type or not(*)]">
                                <xsl:variable name="message_root_name"><xsl:value-of select="$soap_operation"/><xsl:text>:</xsl:text><xsl:value-of select="$soap_operation"/></xsl:variable>
                                <xsl:call-template name="create_service_call">
                                    <xsl:with-param name="binding_name" select="$binding_name"/>
                                    <xsl:with-param name="input_message" select="$input_message"/>
                                    <xsl:with-param name="soap_action" select="$soap_action"/>
                                    <xsl:with-param name="service_name" select="$service_name"/>
                                    <xsl:with-param name="message_root_name" select="$message_root_name"/>
                                    <xsl:with-param name="soap_operation" select="$soap_operation"/>
                                    <xsl:with-param name="port_type" select="$port_type"/>
                                    <xsl:with-param name="port_name" select="$port_name"/>
                                    <xsl:with-param name="style" select="$style"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="create_service_call">
                                    <xsl:with-param name="binding_name" select="$binding_name"/>
                                    <xsl:with-param name="input_message" select="$input_message"/>
                                    <xsl:with-param name="soap_action" select="$soap_action"/>
                                    <xsl:with-param name="service_name" select="$service_name"/>
                                    <xsl:with-param name="soap_operation" select="$soap_operation"/>
                                    <xsl:with-param name="port_type" select="$port_type"/>
                                    <xsl:with-param name="port_name" select="$port_name"/>
                                    <xsl:with-param name="style" select="$style"/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:for-each>
                </xsl:for-each>
            </xsl:for-each>
        </xsl:if>
    </xsl:template>
    <xsl:template name="create_service_call">
        <xsl:param name="service_name"/>
        <xsl:param name="binding_name"/>
        <xsl:param name="input_message"/>
        <xsl:param name="soap_action"/>
        <xsl:param name="message_root_name"/>
        <xsl:param name="soap_operation"/>
        <xsl:param name="port_type"/>
        <xsl:param name="port_name"/>
        <xsl:param name="style"/>
        <xsl:element name="hy:rule">
            <xsl:choose>
                <xsl:when test="$style='document'">
                    <xsl:attribute name="desc"><xsl:text>Calls the </xsl:text><xsl:value-of select="$soap_action"/><xsl:text> service. Be warned that this may fire off with other rules if it is not the only one enabled</xsl:text></xsl:attribute>
                </xsl:when>
                <xsl:when test="$style='rpc'">
                    <xsl:attribute name="desc"><xsl:text>Calls the </xsl:text><xsl:value-of select="$soap_action"/><xsl:text> service. Be warned that this may fire off with other rules if it is not the only one enabled</xsl:text></xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:attribute name="desc"><xsl:text>Warning! This calls service but doesn't perform checks on incoming message</xsl:text></xsl:attribute>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:attribute name="disable">false</xsl:attribute>
            <xsl:attribute name="id"><xsl:value-of select="$binding_name"/><xsl:text>_</xsl:text><xsl:value-of select="$soap_operation"/><xsl:text>_</xsl:text><xsl:value-of select="$input_message"/><xsl:text>_Rule</xsl:text></xsl:attribute>
            <xsl:attribute name="priority"><xsl:text>20</xsl:text></xsl:attribute>
            <xsl:element name="hy:head">
                <xsl:element name="hy:result">
                    <xsl:attribute name="id"><xsl:text>Call_Proxy_Service</xsl:text></xsl:attribute>
                    <xsl:element name="hy:operator">
                        <xsl:text>Service</xsl:text>
                    </xsl:element>
                    <xsl:element name="hy:target">
                        <xsl:attribute name="action"><xsl:value-of select="$soap_action"/></xsl:attribute>
                        <xsl:attribute name="name">
                            <xsl:value-of select="$Blueprint_Type"/>
                            <xsl:text>-</xsl:text>
                            <xsl:value-of select="$Blueprint_Instance"/>
                            <xsl:text>-</xsl:text>
                            <xsl:value-of select="$Chosen_Name_Prefix"/>
                            <xsl:value-of select="translate($service_name, '- ', '_')"/>
                            <xsl:text>_Proxy-</xsl:text>
                            <xsl:value-of select="$Chosen_Name_Prefix"/>
                            <xsl:value-of select="translate($port_name, '- ', '_')"/>
                        </xsl:attribute>

                        <xsl:attribute name="update"><xsl:text>append</xsl:text></xsl:attribute>
                        <xsl:element name="hy:params">
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>from_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/</xsl:text>
                            </xsl:element>
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>to_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/</xsl:text>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
            <xsl:element name="hy:body">
                <xsl:if test="$style = ('rpc' or 'document')">
                    <xsl:element name="clause" xmlns="http://www.hyfinity.com/xengine">
                        <xsl:attribute name="id"><xsl:text>Check_for_Message_Root_Element</xsl:text></xsl:attribute>
                        <xsl:attribute name="multiple"><xsl:text>false</xsl:text></xsl:attribute>
                        <xsl:element name="operator">
                            <xsl:text>Read</xsl:text>
                        </xsl:element>
                        <xsl:element name="target">
                            <xsl:attribute name="action"><xsl:text>eval</xsl:text></xsl:attribute>
                            <xsl:attribute name="name"><xsl:text>factbase</xsl:text></xsl:attribute>
                            <xsl:element name="params">
                                <xsl:element name="param">
                                    <xsl:attribute name="name"><xsl:text>xpath_expression</xsl:text></xsl:attribute>
                                    <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                    <xsl:text>/soap:Envelope/soap:Body/</xsl:text>
                                    <xsl:value-of select="$message_root_name"/>
                                </xsl:element>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:if>
            </xsl:element>
        </xsl:element>
    </xsl:template>


    <xsl:template name="add_optional_soap_wrapper">
        <xsl:element name="hy:rule">
            <xsl:attribute name="disable"><xsl:text>false</xsl:text></xsl:attribute>
            <xsl:attribute name="desc"><xsl:text>This rule allows the user to optionally add a soap wrapper to the message</xsl:text></xsl:attribute>
            <xsl:attribute name="id"><xsl:text>Apply_Soap_Wrapper</xsl:text></xsl:attribute>
            <xsl:attribute name="priority"><xsl:text>10</xsl:text></xsl:attribute>
            <xsl:element name="hy:head">
                <xsl:element name="hy:result">
                    <xsl:attribute name="id"><xsl:text>Add_Soap_Wrapper</xsl:text></xsl:attribute>
                    <xsl:element name="hy:operator">
                        <xsl:text>Transform</xsl:text>
                    </xsl:element>
                    <xsl:element name="hy:target">
                        <xsl:attribute name="action"><xsl:text>transform</xsl:text></xsl:attribute>
                        <xsl:attribute name="name"><xsl:text>XSLT</xsl:text></xsl:attribute>
                        <xsl:attribute name="update"><xsl:text>append</xsl:text></xsl:attribute>
                        <xsl:element name="hy:params">
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>stylesheet</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>java.io.File</xsl:text></xsl:attribute>
                                <xsl:text>Soap_Wrapper.xsl</xsl:text>
                            </xsl:element>
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>from_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/</xsl:text>
                            </xsl:element>
                            <xsl:element name="hy:param">
                                <xsl:attribute name="name"><xsl:text>to_location</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>/</xsl:text>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
            <xsl:element name="hy:body">
                <xsl:element name="clause" xmlns="http://www.hyfinity.com/xengine">
                    <xsl:attribute name="id"><xsl:text>Check_for_Wrapper</xsl:text></xsl:attribute>
                    <xsl:attribute name="multiple"><xsl:text>false</xsl:text></xsl:attribute>
                    <xsl:element name="operator">
                        <xsl:text>Read</xsl:text>
                    </xsl:element>
                    <xsl:element name="target">
                        <xsl:attribute name="action"><xsl:text>eval</xsl:text></xsl:attribute>
                        <xsl:attribute name="name"><xsl:text>factbase</xsl:text></xsl:attribute>
                        <xsl:element name="params">
                            <xsl:element name="param">
                                <xsl:attribute name="name"><xsl:text>xpath_expression</xsl:text></xsl:attribute>
                                <xsl:attribute name="type"><xsl:text>com.hyfinity.xpath.XPath</xsl:text></xsl:attribute>
                                <xsl:text>not(/soap:Envelope)</xsl:text>
                            </xsl:element>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>
