
<xsl:stylesheet version="1.0" xmlns="http://www.hyfinity.com/xfactory" xmlns:xstore="http://www.hyfinity.com/xstore" xmlns:xg="http://www.hyfinity.com/xgate" xmlns:hy="http://www.hyfinity.com/xengine" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xfact="http://www.hyfinity.com/xfactory" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output encoding="UTF-8" indent="yes" method="xml" version="1.0"/>
    <xsl:variable name="Chosen_Name_Prefix">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Name_Prefix']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Project_Layer">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Project_Layer']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Collection">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Collection']"/>
    </xsl:variable>
    <xsl:variable name="Chosen_Pattern_Instance_Pool">
        <xsl:value-of select="/xg:message/xg:header/xg:attributes/xg:attribute[@xg:name='Chosen_Pattern_Instance_Pool']"/>
    </xsl:variable>
    <!--<xsl:variable name="pool_ref">
        <xsl:text>ExampleWSDL_L3_pattern_instance_pool</xsl:text>
    </xsl:variable>-->
    <!--
    match on root template to begin processing
    -->
    <xsl:template match="/">
        <Proxy_Patterns xmlns="http://www.hyfinity.com/xfactory">
            <xsl:apply-templates mode="generate_proxy_pattern" select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:service"/>
        </Proxy_Patterns>
    </xsl:template>
    <xsl:template match="wsdl:service" mode="generate_proxy_pattern">
        <!--we create a pattern element for each service that is found and treat each one as a seperate entity-->
        <pattern base="" desc="" image="" version=""
                 name="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}_Proxy.xml"
                 pattern_id="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}_Proxy">
            <nodes>
                <!-- This part cycles through the ports which are mapped to be nodes
                     For now we ignore ports that only provide soap 1.2 addresses as this is not supported. -->
                <xsl:apply-templates mode="process_port" select="wsdl:port[*[namespace-uri() != 'http://schemas.xmlsoap.org/wsdl/soap12/']]"/>
            </nodes>
        </pattern>
    </xsl:template>

    <xsl:template match="wsdl:port" mode="process_port">

        <node desc="" image=""
              name="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}"
              node_id="{$Chosen_Name_Prefix}{translate(@name, '- ', '_')}"
              protocol="java"
              runtime_instance=""
              runtime_location=""
              type="xagent">

            <!--variable to hold the name of the matching binding elements-->
            <xsl:variable name="binding_name">
                <xsl:choose>
                    <xsl:when test="contains(@binding,':')">
                        <xsl:value-of select="substring-after(@binding,':')"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="@binding"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>

            <actions>
                <xsl:apply-templates mode="process_action" select="/xg:message/xg:body/hy:XStore_Response/xstore:xstore/xstore:content/wsdl:definitions/wsdl:binding[@name=$binding_name]"/>
            </actions>

            <!-- Engine details are not really important for proxy nodes-->
            <engine desc="no engine required" name="XGate Proxy" runtime_instance="com.hyfinity.xgate" type="http">
                <logicsheet desc="" name="" logicsheet_ref=""/>
                <other_resources/>
            </engine>

        </node>
    </xsl:template>

    <!--this template processes the operations in the binding elements to produce the action elements required for the pattern instance file-->
    <xsl:template match="wsdl:binding" mode="process_action">
        <xsl:for-each select="wsdl:operation">

            <xsl:variable name="actionName">
                <xsl:choose>
                    <xsl:when test="soap:operation/@soapAction!=''">
                        <xsl:value-of select="soap:operation/@soapAction"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="@name"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>

            <!-- check this is not going to give a duplicate action name to one already processed -->
            <xsl:if test="not(preceding-sibling::wsdl:operation[((soap:operation/@soapAction != '') and (soap:operation/@soapAction = $actionName)) or (not(soap:operation/@soapAction != '') and (@name = $actionName))])" >
                <action content_type="xml" desc="" name="requestInboundService" alias="{$actionName}">
                    <input desc="" message_name="" message_ref="" name="request" type="org.w3c.dom.Node"/>
                    <output desc="" message_name="" message_ref="" name="response" type="org.w3c.dom.Node"/>
                </action>
            </xsl:if>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>
