/**
 * Contains the script functions relating to selecting and viewing data soruces on the
 * RHS of the structure screen.
 * Copyright (c) 2009 Hyfinity Ltd.
 */

var dataSourceSelected = new Object();

/**
 * Initialises the display of all the data source selection options.
 * This sets it so that nothin has been selected.
 */
function dataSourceDisplayInit()
{
    renderDataSourceTypes();
    //deselect all data source type radio buttons
    var objDataSourceTypes = document.getElementById('data_source_type_selection').getElementsByTagName("input");
    for(var i=0; i<objDataSourceTypes.length; i++)
    {
        objDataSourceTypes[i].checked = false;
    }

    //hide all the stuff related to selected types
    hideComponent(document.getElementById('data_source_db_selection'));
    hideComponent(document.getElementById('data_source_element_selection'));
    hideComponent(document.getElementById('data_source_file_selection'));

    //clear out any previously selected document
    document.getElementById('data_source_file_display').innerHTML = '';
    document.getElementById('data_source_db_display').innerHTML = '';
    document.getElementById("data_source_app_frame_id").src = '';
    hideComponent(document.getElementById('data_source_db_table_selection_area'));

    //initialise the selected data source object.
    dataSourceSelected = new Object();

    //ensure that we dont try to load any documents etc.
    document.formStructure_form.default_structure_type.value = 'DataSource';

    //TODO: Work out the details of the previous datasource, and initiate the display
    //for it, rather than forgetting what was displayed.

}

function renderDataSourceTypes()
{
    var strDataSourceTypes = '';
    strDataSourceTypes += '<span class="selectBoolean"><input type="radio" id="data_source_type_xsd" name="data_source_type" value="xsd" onclick="dataSourceTypeChanged(this.value, \'' + "Schema" + '\')"></input></span>'
    strDataSourceTypes += '<label class="selectBooleanCaption" for="data_source_type_xsd">W3C Schema</label><br/>'
    strDataSourceTypes += '<span class="selectBoolean"><input type="radio" id="data_source_type_wsdl" name="data_source_type" value="wsdl" onclick="dataSourceTypeChanged(this.value, \'' + "WSDL" + '\')"></input></span>'
    strDataSourceTypes += '<label class="selectBooleanCaption" for="data_source_type_wsdl">Service Definition</label><br/>'
    strDataSourceTypes += '<span class="selectBoolean"><input type="radio" id="data_source_type_db" name="data_source_type" value="db" onclick="dataSourceTypeChanged(this.value, \'' + "DB" + '\')"></input></span>'
    strDataSourceTypes += '<label class="selectBooleanCaption" for="data_source_type_db">Database</label><br/>'

    //Render the different data source apps
    var strDataSourceApps = '';
    for (var objDataSourceApp in objDataSourceApps)
    {
        strDataSourceApps += '<span class="selectBoolean"><input type="radio" id="data_source_type_app_' + objDataSourceApp + '" name="data_source_type" value="app" onclick="dataSourceTypeChanged(this.value, \'' + objDataSourceApp + '\')"></input></span>'
        strDataSourceApps += '<label class="selectBooleanCaption" for="data_source_type_app_' + objDataSourceApp + '">' + objDataSourceApp + '</label></br>'
    }
    strDataSourceTypes += strDataSourceApps;
    document.getElementById('data_source_type_selection').innerHTML = strDataSourceTypes;
}

/**
 * Called when the user selects one of the data source type radio buttons.
 * @param newValue The ID value of the selected radio button.
 */
function dataSourceTypeChanged(newValue, strDataSourceApp)
{

    strType = newValue;
    if(strType == "app")
    {
        strType = "xsd";
    }
    dataSourceSelected = new Object();
    dataSourceSelected.type = strType;

    //clear out any previously selected document
    document.getElementById('data_source_file_display').innerHTML = '';
    document.getElementById('data_source_db_display').innerHTML = '';
    hideComponent(document.getElementById('data_source_db_table_selection_area'));
    hideComponent(document.getElementById('data_source_app_selection_area'));
    hideComponent(dojo.byId('DefaultStructureTreeview'));
    hideComponent(document.getElementById('data_source_app_frame_id'));

    switch (newValue)
    {
        case 'wsdl': hideComponent(document.getElementById('data_source_db_selection'));
                     hideComponent(document.getElementById('data_source_element_selection'));
                     showComponent(document.getElementById('data_source_file_selection'));
                     document.getElementById('data_source_file_selection_anchor').innerHTML = 'WSDL File:';
                     form.default_structure_type.value = 'WSDL';
                     dataSourceSelectDocument();
                     break;
        case 'xsd' : hideComponent(document.getElementById('data_source_db_selection'));
                     hideComponent(document.getElementById('data_source_element_selection'));
                     showComponent(document.getElementById('data_source_file_selection'));
                     document.getElementById('data_source_file_selection_anchor').innerHTML = 'Schema File:';
                     form.default_structure_type.value = 'Schema';
                     dataSourceSelectDocument();
                     break;
        case 'db' :  showComponent(document.getElementById('data_source_db_selection'));
                     hideComponent(document.getElementById('data_source_element_selection'));
                     hideComponent(document.getElementById('data_source_file_selection'));
                     form.default_structure_type.value = 'DB';
                     dataSourceSelectDatabase();
                     break;
        case 'app' :
                     showComponent(document.getElementById('data_source_app_frame_id'));
                     hideComponent(document.getElementById('data_source_db_selection'));
                     hideComponent(document.getElementById('data_source_element_selection'));
                     hideComponent(document.getElementById('data_source_file_selection'));
                     form.default_structure_type.value = 'Schema';
                     dataSourceSelectApp(strDataSourceApp);
                     break;

    }
}

/**
 * Called when the user clicks the button to select a data structure file (xsd or wsdl)
 */
function dataSourceSelectDocument()
{
    document.xstoreViewerCaller.xml_permissions.value =
        "<xstores filter='on' xmlns='http://www.hyfinity.com/xengine'>" +
            "<xstore name='" + schemaXStore + "'>" +
                "<collections>" +
                    "<collection name='" + schemaCollection + "'/>" +
                "</collections>" +
            "</xstore>" +
        "</xstores>";
    document.xstoreViewerCaller.chosen_xstore_name.value = schemaXStore;
    document.xstoreViewerCaller.chosen_collection_name.value = schemaCollection;
    window.open('about:blank','xstoreViewerWindow','width=1000, height=600, toolbar=no, menubar=no, location=no, directories=no, scrollbars=yes, resizable=yes, status=no');

    document.xstoreViewerCaller.selection_mode.value = 'content';
    if (dataSourceSelected.type == 'xsd')
        document.xstoreViewerCaller.name_filter.value = '(?i).*\\.xsd$';
    else
        document.xstoreViewerCaller.name_filter.value = '(?i).*\\.wsdl$';

    window.xstoreViewer = dataSourceDocSelectionXSVHandler;
    document.xstoreViewerCaller.submit();
}

/**
 * XstoreViewer callback function to handle the selection of a schema/wsdl document to display.
 */
function dataSourceDocSelectionXSVHandler(xstoreName, collectionName, documentName,
                                          xstoreId, collectionId, documentId,
                                          content)
{
    dataSourceSelected.xstoreName = xstoreName;
    dataSourceSelected.collectionName = collectionName;
    dataSourceSelected.documentName = documentName;
    dataSourceSelected.xstoreId = xstoreId;
    dataSourceSelected.collectionId = collectionId;
    dataSourceSelected.documentId = documentId;

    document.getElementById('data_source_file_display').innerHTML = documentName;
    hideComponent(dojo.byId('DefaultStructureTreeview'));

    if (dataSourceSelected.type == 'xsd')
    {   //should be xsd
        dataSourceShowSchemaElements(content);
    }
    else
    {   //should be wsdl
        dataSourceShowWSDLOperations(content);
    }
}

/**
 * Called when a schema has been selected from XSV.
 * This parses the schema file provided to populate a dropdown of all the available schema root elements.
 * @param content The XML document containing the Schema to parse.
 */
function dataSourceShowSchemaElements(content)
{
    var contentDoc = getXMLDocument(new XMLSerializer().serializeToString(content));
    Sarissa.setXpathNamespaces(contentDoc, 'xmlns:xs="http://www.w3.org/2001/XMLSchema"');

    var lbl = document.getElementById('data_source_element_selection_label');
    var detail = document.getElementById('data_source_element_selection_display');

    var rootElems = contentDoc.selectNodes("/xs:schema/xs:element[@name]");
    if (rootElems.length == 0)
    {
        lbl.colSpan = 2;
        lbl.innerHTML = 'Invalid W3C Schema - No Root Elements Defined.';
        detail.innerHTML = '';
    }
    else
    {
        lbl.colSpan = 1;
        lbl.innerHTML = 'Select Root Element:';

        var selectHTML = '<select id="" onchange="dataSourceSchemaElementSelected(this.value)">'
                        + '<option value="">Please Select</option>';

        for (var i = 0; i < rootElems.length; ++i)
        {
            var elemName = rootElems.item(i).getAttribute('name');
            selectHTML += '<option value="' + elemName + '">' + elemName + '</option>';
        }

        selectHTML += '</select>'

        detail.innerHTML = selectHTML;
    }
    showComponent(document.getElementById('data_source_element_selection'));
}

/**
 * Called when a specific schema root element has been selected.
 * This actually makes the call to the server to load up the schema and convert to a
 * structure file for display. (Using the loadDefaultStructure() function)
 * @param elemName The name of the root element to display the structure for.
 */
function dataSourceSchemaElementSelected(elemName)
{
    if (elemName != '')
    {
        dataSourceSelected.rootElement = elemName;

        document.formStructure_form.schema_filename.value = dataSourceSelected.documentName;
        document.formStructure_form.default_structure_filename.value = dataSourceSelected.documentName;
        document.formStructure_form.schema_root_element.value = dataSourceSelected.rootElement;
        document.formStructure_form.page_source_type.value = 'xsd';

        loadDefaultStructure();
    }
}

/**
 * Called when a WSDL has been selected from XSV.
 * This parses the wsdl file provided to populate a dropdown of all the available wsdl operations.
 * @param content The XML document containing the WSDL to parse.
 */
function dataSourceShowWSDLOperations(content)
{
    var contentDoc = getXMLDocument(new XMLSerializer().serializeToString(content));
    Sarissa.setXpathNamespaces(contentDoc, 'xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"');

    var lbl = document.getElementById('data_source_element_selection_label');
    var detail = document.getElementById('data_source_element_selection_display');

    var operations = contentDoc.selectNodes("/wsdl:definitions/wsdl:binding/wsdl:operation[@name]");
    if (operations.length == 0)
    {
        lbl.colSpan = 2;
        lbl.innerHTML = 'Invalid WSDL - No operations defined.';
        detail.innerHTML = '';
    }
    else
    {
        lbl.colSpan = 1;
        lbl.innerHTML = 'Select Operation:';

        var selectHTML = '<select id="" onchange="dataSourceWSDLOperationSelected(this.value)">'
                        + '<option value="">Please Select</option>';

        var portTypes = contentDoc.selectNodes("/wsdl:definitions/wsdl:portType");
        for (var i = 0; i < portTypes.length; ++i)
        {
            var ptName = portTypes.item(i).getAttribute('name');
            selectHTML += '<optgroup label="' + ptName + '">';

            var portOps = portTypes.item(i).selectNodes("wsdl:operation[@name]");

            for (var j=0; j < portOps.length; ++j)
            {
                var opName = portOps.item(j).getAttribute('name');
                var opNum = dataSourceFindWSDLOperationDuplicateNumber(portOps, j)
                selectHTML += '<option value="' + ptName + '*@*@*' + opName + '*@*@*' + opNum + '">' + opName;
                if (opNum > 1)
                    selectHTML += ' (' + opNum + ')';
                selectHTML += '</option>';
            }

            selectHTML += '</optgroup>';
        }

        selectHTML += '</select>'

        detail.innerHTML = selectHTML;
    }
    showComponent(document.getElementById('data_source_element_selection'));
}

function dataSourceFindWSDLOperationDuplicateNumber(ops, index)
{
    var testName = ops.item(index).getAttribute('name');
    var count = 0;
    for (var i = 0; i <= index; ++i)
    {
        if (ops.item(i).getAttribute('name') == testName)
            count++;
    }
    return count;
}

/**
 * Called when a specific WSDL operation has been selected.
 * This actually makes the call to the server to load up the wsdl and convert to a
 * structure file for display. (Using the loadDefaultStructure() function)
 * @param opName The name of the operation to display the structure for.
 */
function dataSourceWSDLOperationSelected(opName)
{
    if (opName != '')
    {
        dataSourceSelected.operationName = opName;

        document.formStructure_form.schema_filename.value = dataSourceSelected.documentName;
        document.formStructure_form.default_structure_filename.value = dataSourceSelected.documentName;
        document.formStructure_form.request_operation.value = dataSourceSelected.operationName;
        document.formStructure_form.response_operation.value = dataSourceSelected.operationName;
        document.formStructure_form.page_source_type.value = 'wsdl';

        loadDefaultStructure();
    }
}

/**
 * Called when the user clicks the button to select a database
 */
function dataSourceSelectDatabase()
{
    window.open("", "serviceCallHelperWindow", 'width=900, height=400, toolbar=no, menubar=no, directories=no, scrollbars=yes, resizable=yes, status=yes');
    document.serviceCallHelperCaller.submit();
    window.serviceCallHelper = dataSourceDBSelectionSCHHandler;
}


/**
 * Callback function from serviceCallHelper indicating the details of the selected db connection
 */
function dataSourceDBSelectionSCHHandler(target, pattern, node, action)
{
    //alert('selected: ' + target + " : " + pattern + " : " + node + " : " + action);
    dataSourceSelected.dbConnection = target;
    document.getElementById('data_source_db_display').innerHTML = pattern;
    hideComponent(dojo.byId('DefaultStructureTreeview'));
    dataSourceRetrieveTableList();
}


var dataSourceDBTableListTransform = null;

function dataSourceRetrieveTableList()
{
    showComponent(document.getElementById('data_source_db_table_selection_area'));
    document.getElementById('data_source_db_table_selection_area').innerHTML = 'Loading...';

    var dbhelperRequest = '<dbhelper_request xmlns="">'
                                + '<action>list_tables</action>'
                                + '<user>' + document.serviceCallHelperCaller.username.value + '</user>'
                                + '<connection>' + dataSourceSelected.dbConnection + '</connection>'
                            + '</dbhelper_request>';

    dojo.xhrGet(
        {
            url: 'FormMaker',
            content:
                {
                    action: 'process',
                    operation1: 'call_dbhelper',
                    xml_dbhelper_request: dbhelperRequest,
                    xml_project_info: document.formStructure_form.xml_project_info.value
                },
            preventCache: true,
            load: function (response, ioArgs)
                {
                    if (dataSourceDBTableListTransform == null)
                    {
                        dataSourceDBTableListTransform = new SimpleTransform("xsl/clientside_db_render_table_list.xsl",
                                                                             document.getElementById('data_source_db_table_selection_area'));
                    }

                    dataSourceDBTableListTransform.transform(response);
                    hideComponent(document.getElementById('data_source_db_table_usage_row'));
                },
            error: function (response, ioArgs)
                {
                    document.getElementById('data_source_db_table_selection_area').innerHTML = 'Unable to retrieve table listing. Cause: ' + response;
                }
        });
}

function dataSourceDBTableSelected(tableName)
{
    hideComponent(dojo.byId('DefaultStructureTreeview'));
    if (tableName != '')
    {
        dataSourceSelected.dbTableName = tableName;
        showComponent(document.getElementById('data_source_db_table_usage_row'));
        document.getElementById('data_source_db_table_usage').selectedIndex = 0;
    }
    else
    {
        hideComponent(document.getElementById('data_source_db_table_usage_row'));
    }
}

function dataSourceDBUsageSelected(usageType)
{
    if (usageType != '')
    {
        dataSourceSelected.dbUsage = usageType;

        document.formStructure_form.schema_filename.value = '';
        document.formStructure_form.default_structure_filename.value = dataSourceSelected.dbConnection;
        document.formStructure_form.schema_root_element.value = dataSourceSelected.dbTableName;
        document.formStructure_form.request_operation.value = dataSourceSelected.dbUsage;
        document.formStructure_form.page_source_type.value = 'wsdl';

        loadDefaultStructure();
    }
    else
    {
        hideComponent(dojo.byId('DefaultStructureTreeview'));
    }
}

/**
* Called when an external application is to be used to retrieve a real-time schema during page design.
* @param strAppName Name of the selected app.
*/
function dataSourceSelectApp(strAppName)
{
    strSelectedDataSourceApp = strAppName;
    showComponent(document.getElementById('data_source_app_selection_area'));
    //Retrieve session info from the clipboard that should have been supplied when xde was invoked.
    var clipboardItemId = "single_item";
    var clipboardType = "design";
    var clipboardLevel = "user";
    //Supply the callback function that should be called when the session info has been loaded from the clipboard.
    getClipboardItem(clipboardItemId, clipboardType, clipboardLevel, "callDataSourceApp");
}

//Name of the selected datasource app.
var strSelectedDataSourceApp;

/**
* Prepare the request url and make a call to the external datasource application that will return a schema for page design.
*/
function callDataSourceApp()
{
    //Compose the general webmaker fragment that will be used to send info about the project and the application 'navigator' application info that will call the actual external system.
    var strWebmakerDetails = "xml_datasource_details=";
    strWebmakerDetails += "<info><schema_xstore>" + schemaXStore + "</schema_xstore>";
    strWebmakerDetails += "<schema_collection>" + schemaCollection + "</schema_collection>";
    strWebmakerDetails += "<datasource_schema_file>" + objDataSourceApps[strSelectedDataSourceApp].schema + "</datasource_schema_file>";
    strWebmakerDetails +=  document.formStructure_form.xml_project_info.value;
    strWebmakerDetails += "</info>";

    //If session info was supplied then compose the external application details that will be required to call the external app.
    var strAppDetails = "";
    if (objClipboardResponse != null)
    {
        var strDataSourceAppUrl = "";
        var objDataSourceAppUrl = objClipboardResponse.selectSingleNode("/soap:Envelope/soap:Body/xfact:get_clipboard_item/xfact:response/xfact:content/xfact:item/xfact:content/xfact:session_info/xfact:datasource_app_url");
        if (objDataSourceAppUrl != null && objDataSourceAppUrl.firstChild != null && objDataSourceAppUrl.firstChild.nodeValue != null)
        {
            strDataSourceAppUrl = objDataSourceAppUrl.firstChild.nodeValue;
        }
        var strSessionString = "";
        objSessionString = objClipboardResponse.selectSingleNode("/soap:Envelope/soap:Body/xfact:get_clipboard_item/xfact:response/xfact:content/xfact:item/xfact:content/xfact:session_info/xfact:session_string");
        if (objSessionString != null && objSessionString.firstChild != null)
        {
            strSessionString = xmlToString(objSessionString.firstChild);
        }

        strDataSourceAppUrl = URLencode(strDataSourceAppUrl);
        strSessionString = URLencode(strSessionString);

        strAppDetails += "xml_datasource_app_details=";
        strAppDetails += "<info>";
        strAppDetails += "<datasource_app_url>" + strDataSourceAppUrl + "</datasource_app_url>";
        strAppDetails += "<session_string>" + strSessionString + "</session_string>";
        strAppDetails += "</info>";
    }

    //Call the local app that will be hosted in the page structure RHS panel iframe to enable search and retrieval of design schema.
    var strURL = objDataSourceApps[strSelectedDataSourceApp].navigator + "?"	+ strWebmakerDetails + "&" + strAppDetails;
    document.getElementById("data_source_app_frame_id").src = strURL;
}

/**
* This is the callback function for the ajax call that returns the location of the schema that was retrieved from the external application.
*/
function setDataSourceSelectAppSchema()
{
    //Type of structure to dsplay on the RHS pane.
    form.default_structure_type.value = 'Schema';
    //name of the element in the schema to display.
    var elemName = objDataSourceApps[strSelectedDataSourceApp].element;
    //Name of the document, containing the selected schema.
    dataSourceSelected.documentName = objDataSourceApps[strSelectedDataSourceApp].schema;
    //XStore collection details to enable retrieval of the schema file.
    dataSourceSelected.xstoreName = schemaXStore;
    dataSourceSelected.collectionName = schemaCollection;
    //Indicate the type of design information.
    dataSourceSelected.type = "xsd";
    //Call to render the schema to enable page design.
    dataSourceSchemaElementSelected(elemName);
}

function URLencode(sStr)
{
    return escape(sStr).
        replace(/\+/g, '%2B').
            replace(/\"/g,'%22').
               replace(/\'/g, '%27');
}






















