window.focus();

//Variable used to store a reference to the UploadController object
var uc = null;


var log = new Log4js.Logger("log");
log.setLevel(Log4js.Level.OFF);
//log.setLevel(Log4js.Level.TRACE); //set the Level
//log.addAppender(new ConsoleAppender(log, false));

log.debug('Initialising....');

window.onload = function()
{
    if (document.getElementById('fileUploadTabButton'))
        showUploadTab('file');

    //adjust the height of the scrollable document contents section
    if (document.getElementById('documentContents'))
    {
        adjustContentsHeight();
        window.onresize = adjustContentsHeight;
    }
}

function adjustContentsHeight()
{
    if (document.getElementById('documentContents'))
    {
        var dc = document.getElementById('documentContents');
        dc.style.height = 'auto'
        var maxHeight = document.documentElement.clientHeight - 26 - findPosY(dc);

        if (dc.clientHeight > maxHeight)
        {
            dc.style.height = maxHeight + 'px';

            //check if there is a selected document, and if so
            //scroll the view to show this line.
            var selectedDoc = findSelectedDocument();
            if ((selectedDoc != null) && (selectedDoc.obj != null))
            {
                scrollViewToShow(dc, selectedDoc.obj);
            }
        }
    }
}


function collectionChosen(xstoreName,collectionName,xstoreId,collectionId)
{
    document.nav.chosen_xstore_name.value=xstoreName;
    document.nav.chosen_collection_name.value=collectionName;
    document.nav.chosen_xstore_id.value=xstoreId;
    document.nav.chosen_collection_id.value=collectionId;
    document.nav.xml_permissions.value=document.getElementById('permissions').value;
    document.nav.operation.value="";
    document.nav.submit();
}
function documentChosen(xstoreName,collectionName,documentName,xstoreId,collectionId,documentId)
{
    //if(confirm('Are you sure you wish to select \n\nxstore = '+xstoreName+'\ncollection = '+collectionName+'\ndocument = '+documentName)){
        window.opener.xstoreViewer(xstoreName,collectionName,documentName,xstoreId,collectionId,documentId);
        window.opener.focus();
        window.close();
    //}
}
function populate_filename()
{
    var value = (currentTab == 'file') ? document.fileUploadForm.document_path.value : document.fileUploadForm.url_path.value;
    findInitialFileName(value);
}

function findInitialFileName(baseName)
{
    if (baseName == '')
        return;

    //take the last part of the file path
    var stringArray = baseName.split('\\');
    var stringArray2 = stringArray.pop().split('/');
    var baseName = stringArray2.pop();

    var fileExtension = getDefaultFileExtension();
    var changeExtension = false;

    //remove any query string section if present
    var queryStringPointer = baseName.indexOf('?');
    if (queryStringPointer != -1)
    {
        var queryString = baseName.substr(queryStringPointer);
        baseName = baseName.substr(0, queryStringPointer);

        //Special handling for specific types of URLs to retrieve WSDLs and XSDs from .NET services
        if (queryString.indexOf('wsdl') != -1)
        {
            fileExtension = '.wsdl';
            changeExtension = true;
        }
        else if (queryString.indexOf('xsd') != -1)
        {
            fileExtension = '.xsd';
            changeExtension = true;
        }
    }

    //add or adjust the file name extension as needed
    if (baseName.indexOf('.') == -1)
        baseName += fileExtension;
    else if (changeExtension)
        baseName = baseName.substr(0, baseName.lastIndexOf('.')) + fileExtension;

    document.fileUploadForm.document_filename.value = baseName;
}

function uploadDocument()
{
    if (currentTab == 'file')
    {
        if (useUploadApplet)
        {
            if (!appletFileSelected)
            {
                alert("Please select a file to upload.");
                return;
            }
        }
        else
        {
            if (document.fileUploadForm.document_path.value == '')
            {
                alert("Please select a file to upload.");
                return;
            }
        }
    }
    else if (currentTab == 'url')
    {
        if (document.fileUploadForm.url_path.value == '')
        {
            alert("Please enter the URL of the document to import.");
            return;
        }
    }

    if (checkName())
    {
        if ((useUploadApplet) && (currentTab == 'file'))
        {
            showStatusMessage('Please wait while your chosen document (and any others it requires) are automatically uploaded.');
            var uploadApplet = document.getElementById('uploadApplet');
            uploadApplet.startUpload(document.fileUploadForm.document_filename.value);
        }
        else
        {
            uc = new UploadController('uc', currentTab);
            uc.start();
        }
    }
}


/** Checks that the value entered in the filename box is valid */
function checkName()
{
    //convert any \ to /
    document.fileUploadForm.document_filename.value = document.fileUploadForm.document_filename.value.replace(/\\/g, '/');
    //check for non word characters
    var filter = /[^\w\.\-\/]/;
    if(filter.test(document.fileUploadForm.document_filename.value))
    {
        alert("Invalid file name. Please do not include non-alphanumeric values or spaces.");
        return false;
    }
    else if(document.fileUploadForm.document_filename.value == "")
    {
        alert("Please enter a file name before submitting");
        return false;
    }

    // try and add the appropriate ending if not present
    if (document.fileUploadForm.document_filename.value.indexOf('.') == -1)
    {
        document.fileUploadForm.document_filename.value += getDefaultFileExtension();
    }


    return true;
}


function getDefaultFileExtension()
{

    var colName = document.nav.chosen_collection_name.value;
    if (colName.toLowerCase().indexOf('xsl') != -1)
    {
        return '.xsl';
    }
    else if (colName.toLowerCase().indexOf('xsd') != -1)
    {
        return '.xsd';
    }
    else
    {
        return '.xml';
    }
}


/** Creates a new empty document, and then opens it in Spy for the user to edit. */
function newDocument()
{
    if (checkName())
    {
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.uploaded_document_filename.value = document.fileUploadForm.document_filename.value;

        if (document.getElementById('newFileContent') != null)
        {
            document.nav.xml_uploaded_document.value = document.getElementById('newFileContent').value;
        }
        else
        {
            var tagName = document.fileUploadForm.document_filename.value;
            //remove the section after the last dot (ie the file type)
            if (tagName.indexOf(".") != -1)
            {
                tagName = tagName.substring(0, tagName.lastIndexOf("."));
            }

            document.nav.xml_uploaded_document.value = '<'+tagName+'/>';
        }

        document.nav.operation.value = "new_document";
        document.nav.chosen_document_name.value = document.fileUploadForm.document_filename.value;
        document.nav.submit();
    }
}

/** Copies a docuemnt in the collection, and opens the copy up in an editor to change as needed. */
function copyDocument()
{
    var selectedDoc = findSelectedDocument();
    if (selectedDoc == null)
    {
        alert("Pleae first select a document to copy.");
        return;
    }

    if (checkName())
    {
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.uploaded_document_filename.value = document.fileUploadForm.document_filename.value;
        document.nav.operation.value = "copy_document";
        document.nav.chosen_document_name.value = selectedDoc.name;
        document.nav.chosen_document_id.value = selectedDoc.id;
        document.nav.submit();
    }
}

/** Renames the selected document. */
function renameDocument()
{
    var selectedDoc = findSelectedDocument();
    if (selectedDoc == null)
    {
        alert("Pleae select a document to rename.");
        return;
    }

    if (checkName())
    {
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.uploaded_document_filename.value = document.fileUploadForm.document_filename.value;
        document.nav.operation.value = "rename_document";
        document.nav.chosen_document_name.value = selectedDoc.name;
        document.nav.chosen_document_id.value = selectedDoc.id;
        document.nav.submit();
    }
}


function deleteDocument()
{
    var selectedDoc = findSelectedDocument();
    if (selectedDoc)
    {
        document.nav.chosen_document_name.value = selectedDoc.name;
        document.nav.chosen_document_id.value = selectedDoc.id;
        document.nav.operation.value = "delete_document";
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.submit();
    }
    else
    {
        alert("Please first select a document to delete.");
    }
}

var xmlhttp;

/** Loads the selected document up in an external editor (ie XMLSpy). */
function editDocument()
{
    var selectedDoc = findSelectedDocument();
    if (selectedDoc)
    {
        xmlhttp = new XMLHttpRequest();

        var requestURL = "xstoreviewer?action=call&operation=edit_document";
        requestURL += "&chosen_xstore_id=" + document.nav.chosen_xstore_id.value;
        requestURL += "&chosen_collection_id=" + document.nav.chosen_collection_id.value;

        //use chosen_document_name as for a new operation (which uses the same edit feature)
        //only the name of the new file is known.
        requestURL += "&chosen_document_name=" + selectedDoc.name;

        xmlhttp.open("POST", requestURL, true);

        xmlhttp.onreadystatechange = editDocumentStateChange;

        xmlhttp.send();
    }
    else
    {
        alert("Please first select a document to edit.");
    }

}

/** Called when a change in state has occurred for the edit document request. */
function editDocumentStateChange()
{
    if ((xmlhttp != null) && (xmlhttp.readyState == 4))
    {
        var responseDoc = getXMLDocument(xmlhttp.responseText);
        Sarissa.setXpathNamespaces(responseDoc, 'xmlns:xstore="http://www.hyfinity.com/xstore"');

        //check for failure
        if (responseDoc.selectSingleNode("/xstore:xstore/xstore:response/xstore:outcome[. = 'success']") == null)
        {
            var error1 = responseDoc.selectSingleNode("/xstore:error");
            var error2 = responseDoc.selectSingleNode("/xstore:xstore/xstore:response/xstore:message");

            var alertMessage = "An error occurred while trying to edit the document.\n\n";
            if (error1 != null)
                alertMessage += getElementText(error1);
            if (error2 != null)
                alertMessage += getElementText(error2);

            alert(alertMessage);
        }
    }
}


function viewDocument()
{
    var checkedRadioValue = findSelectedDocument();
    if(checkedRadioValue)
    {
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.chosen_document_id.value = checkedRadioValue.id;
        document.nav.chosen_document_name.value = checkedRadioValue.name;
        document.nav.operation.value = 'view_document';
        document.nav.submit();
    }
    else
    {
        alert("Please first select a document to view.");
    }
}

function viewModeViewDocument(id, name)
{
    document.nav.xml_permissions.value=document.getElementById('permissions').value;
    document.nav.chosen_document_id.value = id;
    document.nav.chosen_document_name.value = name;
    document.nav.operation.value = 'view_document';
    document.nav.submit();
}

function findSelectedDocument()
{
    var radioArray = document.fileUploadForm.documentSelect;
    var checkedRadioValue = null;
    if (radioArray != null)
    {
        if (radioArray.length)
        {
            for(var i=0; i<radioArray.length ;i++)
            {
                if(radioArray[i].checked)
                {
                    checkedRadioValue = new Object();
                    var parts = radioArray[i].value.split('*@*@*');
                    checkedRadioValue.id = parts[0];
                    checkedRadioValue.name = parts[1];
                    checkedRadioValue.obj = radioArray[i];
                }
            }
        }
        else
        {
            if (radioArray.checked)
            {
                checkedRadioValue = new Object();
                var parts = radioArray.value.split('*@*@*');
                checkedRadioValue.id = parts[0];
                checkedRadioValue.name = parts[1];
                checkedRadioValue.obj = radioArray;
            }
        }
    }
    return checkedRadioValue;
}


function returnDocumentContent(docid, docname)
{
    document.nav.chosen_document_id.value = docid;
    document.nav.chosen_document_name.value = docname;
    document.nav.operation.value = 'return_document';
    document.nav.submit();
}

/** stores the id of the upload tab currently shown. */
var currentTab;

/**
 * Shows the specified upload tab
 */
function showUploadTab(tabType)
{
    currentTab = tabType;
    if (tabType == 'file')
    {
        showComponent(document.getElementById('fileUploadTab'));
        hideComponent(document.getElementById('urlUploadTab'));
        document.getElementById('fileUploadTabButton').className = 'current';
        document.getElementById('urlUploadTabButton').className = '';
    }
    else if (tabType == 'url')
    {
        hideComponent(document.getElementById('fileUploadTab'));
        showComponent(document.getElementById('urlUploadTab'));
        document.getElementById('fileUploadTabButton').className = '';
        document.getElementById('urlUploadTabButton').className = 'current';
    }

}






/**
 * Called when the user has decided what to do about any existing files during the upload process.
 */
function continueUpload(defaultOverwrite)
{
    var statusXML = getXMLIsland('upload_status');
    Sarissa.setXpathNamespaces(statusXML, 'xmlns:xstore="http://www.hyfinity.com/xstore"');

    var files = statusXML.selectNodes("/xstore:import_details/xstore:files/xstore:file[@status = 'exists']");
    for (var i = 0; i < files.length; ++i)
    {
        var fileNode = files.item(i);
        if (typeof(defaultOverwrite) != 'undefined')
            fileNode.setAttribute('overwrite', defaultOverwrite);
        else
        {
            if (document.getElementById(fileNode.getAttribute('name') + '_overwrite').checked)
                fileNode.setAttribute('overwrite', 'true');
            else
                fileNode.setAttribute('overwrite', 'false');
        }

    }

    if (useUploadApplet)
    {
        var uploadApplet = document.getElementById('uploadApplet');
        uploadApplet.continueUpload(xmlToString(statusXML));
    }
    else
    {
        document.nav.xml_permissions.value=document.getElementById('permissions').value;
        document.nav.xml_uploaded_document.value = xmlToString(statusXML);
        document.nav.operation.value="import_documents";
        document.nav.submit();
    }

}

/**
 * Toggles whether all the replace checkboxes are ticked or unticked.
 * If at least one is unticked, they are all ticked, otehrwise they are all unticked.
 */
function toggleReplaceExisting()
{
    var statusXML = getXMLIsland('upload_status');
    Sarissa.setXpathNamespaces(statusXML, 'xmlns:xstore="http://www.hyfinity.com/xstore"');

    var currentChecked = findCurrentReplaceExistingState(statusXML);
    if (currentChecked)
        updateReplaceExisting(statusXML, false);
    else
        updateReplaceExisting(statusXML, true);
}

/**
 * Returns true if all the replace checkboxes are ticked, false otehrwise.
 */
function findCurrentReplaceExistingState(statusXML)
{
    var files = statusXML.selectNodes("/xstore:import_details/xstore:files/xstore:file[@status = 'exists']");
    for (var i = 0; i < files.length; ++i)
    {
        var fileNode = files.item(i);
        if (!document.getElementById(fileNode.getAttribute('name') + '_overwrite').checked)
        {
            return false;
        }
    }
    return true;
}

/**
 * Sets the checked property of all replace checkboxes to the given value.
 */
function updateReplaceExisting(statusXML, newChecked)
{
    var files = statusXML.selectNodes("/xstore:import_details/xstore:files/xstore:file[@status = 'exists']");
    for (var i = 0; i < files.length; ++i)
    {
        var fileNode = files.item(i);
        document.getElementById(fileNode.getAttribute('name') + '_overwrite').checked = newChecked;
    }
}

/**
 * Returns the Y position (in pixels) of the given object
 */
function findPosY(obj)
{
    var curtop = 0;
    if (obj.offsetParent)
    {
        while (obj.offsetParent)
        {
            curtop += obj.offsetTop
            obj = obj.offsetParent;
        }
    }
    else if (obj.y)
        curtop += obj.y;
    return curtop;
}


// ----------- Upload Applet Interaction Functions ------------

var useUploadApplet = false;
var appletFileSelected = false;

/**
 * Called from the applet when it has determined whether it can successfully operate
 * or not. ie does it ahve permision to access local files.
 * @param boolean true if can continue, otherwise false.
 */
function setAppletCanContinue(status)
{
    if (status)
    {
        useUploadApplet = true;
        document.getElementById('appletFileUploadContainer').style.display = 'block';
        document.getElementById('nonAppletFileUploadContainer').style.display = 'none';
    }
    else
    {
        useUploadApplet = false;
        document.getElementById('appletFileUploadContainer').style.display = 'none';
        document.getElementById('nonAppletFileUploadContainer').style.display = 'block';
    }
}

/**
 * Called by the applet when the user has selected a file.
 * @param fileName The name of the file selected.
 */
function fileSelected(fileName)
{
    //alert('you selected ' + fileName);
    appletFileSelected = true;
    findInitialFileName(fileName);
}

/**
 * Called by the applet to get the Id of the xstore we are currently looking at
 */
function getCurrentXStoreID()
{
    return document.nav.chosen_xstore_id.value;
}

/**
 * Called by the applet to get the Id of the collection we are currently looking at
 */
function getCurrentCollectionID()
{
    return document.nav.chosen_collection_id.value;
}

/**
 * Called by the applet when the upload has completed
 * @param statusXMl a String containing the XML status document indiccating the outcome of the
 *          upload process.
 */
function appletUploadResponse(statusXML)
{
    document.nav.xml_permissions.value=document.getElementById('permissions').value;
    document.nav.xml_uploaded_document.value = statusXML;
    document.nav.operation.value="refresh";
    document.nav.submit();
}




// ------------------ Edit page functions ---------------------

function cancelChanges()
{
    if ((!screenHasChanges) || (confirm('You have unsaved changes that will be lost if you continue.')))
    {
        document.editDoc.xml_permissions.value = document.getElementById('permissions').value;;
        document.editDoc.operation.value = 'cancel_document_changes';
        document.editDoc.submit();
    }
}

function saveChanges()
{
    var testDoc = getXMLDocument(editAreaLoader.getValue('xml_docContent'));
    if(Sarissa.getParseErrorText(testDoc) == Sarissa.PARSED_OK)
    {
        document.editDoc.xml_docContent.value = editAreaLoader.getValue('xml_docContent');
        document.editDoc.xml_permissions.value = document.getElementById('permissions').value;;
        document.editDoc.operation.value = 'save_document_changes';
        //document.editDoc.submit();
        showStatusMessage('Saving...');
        dojo.xhrPost({
                form: document.editDoc,
                handleAs: 'text',
                load: function(data)
                {
                    clearChanged();
                    //TODO: Should really check the response to make sure it was successful
                    showStatusMessage('Save Successful', true);
                },
                error: function(error)
                {
                    showStatusMessage('Save failed!');
                }
            });
    }
    else
    {
        alert("Please ensure you enter valid XML content before saving.\n\n\n" + Sarissa.getParseErrorText(testDoc));
    }
}

function saveChangesNonXStore()
{
    document.editDoc.docContent.value = editAreaLoader.getValue('docContent');
    document.editDoc.xml_permissions.value = document.getElementById('permissions').value;;
    document.editDoc.operation.value = 'save_non_xstore';
    //document.editDoc.submit();
    showStatusMessage('Saving...');
    dojo.xhrPost({
            form: document.editDoc,
            handleAs: 'text',
            load: function(data)
            {
                clearChanged();
                //TODO: Should really check the response to make sure it was successful
                showStatusMessage('Save Successful', true);
            },
            error: function(error)
            {
                showStatusMessage('Save failed!');
            }
        });
}

function closeWindow()
{
    //TODO: When we have hooked XSV up to the WinManager we should be able to remove this??
    if ((!screenHasChanges) || (confirm('You have unsaved changes that will be lost if you continue.')))
    {
        window.close();
    }
}

var screenHasChanges = false;

function setChanged()
{
    if (screenHasChanges == false)
    {
        showStatusMessage("Unsaved Changes");
        if(document.title.charAt(0)!="*")
        {
            document.title = "* " + document.title + " (modified)";
        }
        //notify win manger of changes
        //WinManager.setUnsaved(window);
    }

    screenHasChanges = true;
}

function clearChanged()
{
    screenHasChanges = false;

    hideStatusMessage();
    if(document.title.charAt(0) == "*")
    {
        document.title = document.title.substring(2, (document.title.length - 11));
    }

    //clear winmanger changed setting
    //WinManager.clearUnsaved(window);
}

// ------------------ Utility functions ----------------------------


var hideStatusTimeout;
/**
 * Generic function for showing messages in the FormMaker status area.
 * This is on the blue strip below the menu bar.
 *
 * @param msg A string containing the message to display.  This can contain HTML markup.
 * @param autohide optional boolean indicating whether the message should be hidden after a period of time
 */
function showStatusMessage(msg, autohide)
{
    if (hideStatusTimeout != null)
    {
        clearTimeout(hideStatusTimeout);
        hideStatusTimeout = null;
    }

    var messageContainer;
    if (document.forms[0].display_mode.value == 'embeded')
    {
        if (parent != null)
        {
            messageContainer = parent.document.getElementById('gen_response');
            if (messageContainer == null)
            {
                messageContainer = parent.document.createElement('div');
                messageContainer.setAttribute('id', 'gen_response');
                messageContainer.className = 'gen_response';
                parent.document.body.appendChild(messageContainer);
            }
        }
    }
    else
    {
        messageContainer = document.getElementById('gen_response');
        if (messageContainer == null)
        {
            messageContainer = document.createElement('div');
            messageContainer.setAttribute('id', 'gen_response');
            messageContainer.className = 'gen_response';
            document.body.appendChild(messageContainer);
        }
    }

    messageContainer.style.display = 'block';
    messageContainer.innerHTML = msg;

    if (autohide == true)
    {
        hideStatusTimeout = setTimeout(hideStatusMessage, 5000);
    }
}
/**
 * Generic function to hide the visibility of the FormMaker status message.
 */
function hideStatusMessage()
{
    var messageContainer;
    if (document.forms[0].display_mode.value == 'embeded')
    {
        if (parent != null)
        {
            messageContainer = parent.document.getElementById('gen_response');
        }
    }
    else
    {
        messageContainer = document.getElementById('gen_response');
    }
    if (messageContainer != null)
    {
        messageContainer.style.display = 'none';
        messageContainer.innerHTML = '';
    }

}